#include <stdio.h>
#include <string.h>
#include "sap_moni.h"
#include "sap_moni_ccm.h"
#include "agnt_util.h"

#define ERROR 2

/*=======================================================================
  (C) Copyright SAP AG, 2002

         
 Author  : Dostert/SAP
 Project : Get data from R/3 using XMB
 Using   : RFCSDK 
 ========================================================================*/

void usage(char *progname) {
	#define BL printf(   

	 

	 BL"Agent\n\n");	   
	 BL"Syntax: %s <Template> <RFC-Template>\n\n",  progname     );
                                                                  

	 BL"       <Template> defined in %s    \n", AGENT_INI_FILE  );
	 BL"       <RFC-Template> defined in %s\n", AGENT_LOGIN_FILE  );
}



int main(int argc, char **argv) {
	int i,j;

	RFC_HANDLE rfc_handle;
	AlMoniHandle_T *MoniHandle; 
	int   NrOfMoniTempl;
	
	AlMoniNode_T *nodes;
        unsigned int NrOfNodes;	

	char  templ_name[AL_MONI_MAX_TEMPL_NAME_LENGTH];
	int   highest_alert = 0;
	
        char node_info[255];

        char tid_c[85];

        AlMoniTemplate_T *moni_templ;
        BAPITNDEXT *tTreeNodes;

        BAPITID    tid;
        BAPIPAPROP Properties;

	if (argc < 3) {
		usage(argv[0]);
		return ERROR;
	}

	strcpy(templ_name, argv[1]);

	if ( sapmon_init(&MoniHandle, &NrOfMoniTempl) >=  AG_FIRST_ERROR) {
		printf("Could not initialize INI-File\n");
		return ERROR;
	}

	if( sapmon_connect(argv[2], &rfc_handle) >=  AG_FIRST_ERROR) {
		printf("Could not log on\n");
		return ERROR;
	}

	
	for (i = 0; i <  NrOfMoniTempl; i++) {
		if ( strcmp(sapmon_get_template_name(MoniHandle[i]), templ_name) != 0)
			continue;

		sapmon_request(&rfc_handle, &(MoniHandle[i]), 1 );
		sapmon_request_tree(MoniHandle[i], &nodes, &NrOfNodes);	

		for (j = 0; j < NrOfNodes; j++) {
			if (nodes[j].Actualval > highest_alert)
				highest_alert = nodes[j].Actualval;			

			  if (strcmp(nodes[j].Objectname,  nodes[j].Mtnameshrt) != 0) {
                                sprintf(node_info, "%s %s<br> %s %s %s<br><br>",  nodes[j].Mtsysid, nodes[j].Mtmcname, nodes[j].Objectname, nodes[j].Mtnameshrt, nodes[j].currentValue);
                        } else {
                                sprintf(node_info, "%s %s %s<br><br>",  nodes[j].Mtsysid, nodes[j].Mtmcname, nodes[j].Objectname);                                         }

                        moni_templ = get_template_by_handle(MoniHandle[i]);
                        tTreeNodes = ItGetLine( moni_templ->TreeNodes,j+1);
                        if( strncmp(tTreeNodes->Mtclass,  MT_CLASS_PERFORMANCE, 3) == 0) {
                                memset(&tid, ' ', sizeof(tid));

                                strncpy(tid.Mtsysid, tTreeNodes->Mtsysid, 8);
                                strncpy(tid.Mtmcname, tTreeNodes->Mtmcname, 40);
                                strncpy(tid.Mtnumrange, tTreeNodes->Mtnumrange, 3);
                                strncpy(tid.Mtuid, tTreeNodes->Mtuid, 10);
                                strncpy(tid.Mtclass, tTreeNodes->Mtclass,3);
                                strncpy(tid.Mtindex, tTreeNodes->Mtindex, 10);
                                strncpy(tid.Extindex, tTreeNodes->Extindex, 10);

                                bapi_system_mte_getperfprop(&rfc_handle, &tid, &Properties);

                                strncpy(tid_c, (char *)&tid,84);
                                tid_c[84] = '\0';

                                printf("<a href='cmd.cgi?cmd_typ=91&TID=%s&thr_g2y=%d&thr_r2y=%d&thr_y2g=%d&thr_y2r=%d&unit=%s&rfc_template=%s'>%s</a>",
                                        url_encode(tid_c),
                                        Properties.Treshg2y, Properties.Treshr2y,
                                        Properties.Treshy2g, Properties.Treshy2r,
                                        url_encode(Properties.Valunit),
                                        url_encode(argv[2]),
                                        node_info);
                        } else {
                                printf("%s", node_info);
                        }


		}

	}

        //Nothing found
        if (NrOfNodes == 0) {
              highest_alert = 3;
              printf("No information gathered! System up?\n");
        }


	//Log off
	sapmon_disconnect(&rfc_handle);	
	
	return highest_alert -1;
}
